# Sliding Tree Menu

| Required Class Files: slidem.class, occcolor.class, ocfontc.class, ocgifix.class, ocekey.class Notice Tag: "Sliding Tree Menu, Copyright (c) 1997 OpenCube Technologies, Registered (Your Unique Registration #)" |

Required Class Files

This applet uses multiple class files (included with the download), the main class file: slidem.class must be referenced by the applet tag. The other support class files must be located in the same folder as the main class file in order for the applet to run. The required class files are: slidem.class, occcolor.class, ocfontc.class, ocgifix.class, ocekey.class

Applet Tag Template:

- Based on the above sample implementation

Online Documentation at www.opencube.com

- Applet Configuration FAQ
- Technical Document Index

Uploading the applet to the Server

Once you are finished customizing the applet you will need to upload the HTML page containing the applet tag and the applet class files. Be shore to upload the class files in binary format and ensure that they are located in the same folder as identified by the codebase= value in the applet tag.

The Required Parameters:

Parameter 1, the notice tag, must be included in the applet tag in order for the applet to work. The only other required parameters are at least one image file. Usually the easiest way to customize your applet is to cut and paste the applet tag used in the template and modify it to fit your web page.

Defining Colors:

This applet uses a simple RGB or Hexadecimal color definition scheme. On most systems (depending on the software being used to choose a color) its easier to define a color using RGB, however since most web pages define colors using a HEX value we have allowed for both methods of color definition. To define a color using RGB use commas to separate the values such as 255,255,255 (White). To define a color using a hexadecimal value use a pound sign ('#') followed by a 6 digit hex value in the rage of 000000 - FFFFFF (e.g. #FFFFFF is equal to the color White).

Color Definition with RGB: To define a color in one of the color parameters using RGB choose a value between 0 - 255 for the red, green, and blue components separated by commas and typed out in the correct r,g,b order. Below is a sample of how a color parameter using RGB should look, the example specifies several different sample colors for the "bgcolor" parameter.

WHITE: <param name="bgcolor" value="255,255,255">
GREEN: <param name="bgcolor" value="0,255,0">
BLACK: <param name="bgcolor" value="0,0,0">
YELLOW: <param name="bgcolor" value="255,255,0">
OFF WHITE: <param name="bgcolor" value="240,239,234">

The best way to choose the exact color you are looking for without having to guess the numbers is to access your systems Color Picker. Color Pickers usually allow you to drag the mouse over a rainbow type color grid to select a color, and show you the appropriate RGB values. In windows the Color Picker is accessible through MS Paint as well as a majority of the popular Imaging and HTML Authoring Software.

Defining Multiple attributes with One Parameter:

Parameters used to customize a specific image location or sub menu descriptions are indicated using a range, such as "imagefile0" - "imagefileN". To define a parameter for a specific image or message (available when noted as above), use "maindesc0" to define, in this case, the first main menu description, "maindesc1" would define the second main menu description, etc.

The Applet Coordinate System:

The origin of the applets coordinate system is located at the upper left corner of the applet. The x (horizontal) coordinate starts at the left border with 0 and go as far to the right as the applet is wide (defined with the width tag - see above). The y (vertical) coordinate starts at the top of the applet with 0 and go down as far as the applet is high.

The Applet Parameters

General Settings

Parameter 1
Attribute: Copyright notice.
param name="Notice"
value="Sliding Tree Menu, Copyright (c) 1997 OpenCube Technologies, Registered (Your Unique Registration #)"
Note: This must be included for the applet to work.

Parameter 2
Attribute: Applet Background Color
param name = "bgcolor"
Value = R,G,B, Where R,G,B are the red, green, and blue components of the applets background color.

Parameter 3
Attribute: Default Status Bar Text when mouse is over applet
param name = "onsbtext"
value="X", where X is the message to appear in the status bar when the mouse is over the applet but not over a URL link.
DEFAULT: OpenCube - Sliding Tree Menu

Parameter 4
Attribute: Loading Images Message
param name = "loadmsg"
value="X", where X is the message to appear in the applet area while the images are loading.
DEFAULT: Loading Images...

Parameter 5
Attribute: Loading Images Message Color
param name = "loadmsgcolor"
Value=r,g,b or #000000 - #FFFFFF - See above for more information on defining colors.
DEFAULT: White

Parameter 6
Attribute: Default Status Bar Text when mouse is off applet
param name = "offsbtext"
value="X", where X is the message to appear in the status bar when the mouse is not over the applet.
DEFAULT: Java by OpenCube

Parameter 7
Attribute: Slide Animation Jump Size
param name = "jumpsize"
Value = X, Where x is the number of pixels to move between frame draws, the higher the number the faster the animation.
DEFAULT: 1

Main Menu Settings

The main menu portion of the slide menu, which is comprised of the first level links can be sized and customized to be distinguished from the sub levels of the menu. A background image option is available which can optionally be tiled. To use a graphic background which matches the main menu links which are sized with a height option, turn off tiling and adjust the menu areas vertically with the top offset parameter. The height of each main menu can be set and therefore correspond exactly to sections of a non tiled or tiled background image for an added effect.

Parameter 8
Attribute: Main Menu Descriptions
param name = "maindesc0" - "maindescN"
Value = Icon ID | Description or Description, Where description is the description for each main menu link. Use an icon id then a vertical bar separator - | - followed by the menus description to associate an icon with the menu link. To just use a message without an icon for the menu area leave the icon ID and vertical bar out of the value. For more information on icons see the Icon Images section.

Parameter 9
Attribute: Main Background Color
param name = "mbgcolor"
Value=r,g,b or #000000 - #FFFFFF - See above for more information on defining colors. The main background color will be displayed if a tiled background image does not exist or the background image does not completely fill the applet area.
DEFAULT: Applet background color - White

Parameter 10
Attribute: Main Background Image File
param name = "mbgfile"
Value = X. Where X is the name and relative location of the background image file to use. The file should be defined relative to the location of the document containing the applet or fully qualified (e.g. http://www.mydomain.com/...).

Parameter 11
Attribute: Tile Background Image?
param name = "mtilebg"
Value = true or false, true = yes tile the background image, false = no, draw one image at the left, top edge of the applet.
DEFAULT: true

Parameter 12
Attribute: Draw Background Color or Image Behind the Main Menu Area Only
param name = "mbgonmenusonly"
Value = true or false, true = yes, the background image will only display to the bottom of the main menu link area. No the background image will fill the entire applet.

Parameter 13
Attribute: Retract from off screen
param name = "rfromoff"
Value = true or false, true = yes, if the menu slides off screen the graphics will be saved an displayed when retracted. false = no, if the menu slides off screen the graphics will not be saved and will be cut off when retracted. Note: It is recommended to set this setting to false if it is know that the menu system cannot display lower thean the applet area.
DEFAULT: true

Parameter 14
Attribute: Main Menu Top Offset
param name = "topoffset"
Value = X, Where x is the distance in pixels to start the first main menu link.
DEFAULT: 0

Parameter 15
Attribute: Main Menu Height
param name = "mheight"
Value = X, Where x is the height for each main menu area. Leaving the parameter out of the tag or a setting of -1 will automatically adjust the height to the size of the main menu font.
DEFAULT: -1

Parameter 16
Attribute: Main Text Indent
param name = "mindent"
Value = X, Where x is distance from the left edge of the applet to indent the main menu text descriptions.
DEFAULT: 10

Parameter 17
Attribute: Main Font Style
param name = "mfont"
Value = Font Face, Style, Size, Each value must be separated by a comma and appear in the correct order (font face, style, and size) The Allowable Java font face values are Helvetica, TimesRoman, Courier, Dialog, or DialogInput. The alowable style options are plain, bold, bolditalic, or italic.
DEFAULT: Helvetica, plain, 12

Parameter 18
Attribute: Main Text Color
param name = "mtextcolor"
Value=r,g,b or #000000 - #FFFFFF - See above for more information on defining colors.
DEFAULT: Black

Parameter 19
Attribute: Main Outline Color
param name = "moutcolor"
Value=r,g,b or #000000 - #FFFFFF - See above for more information on defining colors. Defines the color of the box which outlines each main menu link. When left out of the tag the outline will not be displayed.
DEFAULT: Not Present

Main Menu Highlight Settings

Note: Highlighting main menus with icons will automatically display the icons associated switch image. For more information about defining icons see the icon images section.

Parameter 20
Attribute: Main Background Highlight Color
param name = "mhlbgcolor"
Value=r,g,b or #000000 - #FFFFFF - See above for more information on defining colors. If not defined the highlight will not draw a background color and any existing background image or color will be preserved.
DEFAULT: Not Present

Parameter 21
Attribute: Main Highlight Text Color
param name = "mhltextcolor"
Value=r,g,b or #000000 - #FFFFFF - See above for more information on defining colors.
DEFAULT: Red

Parameter 22
Attribute: Main Highlight Outline Color
param name = "mhloutcolor"
Value=r,g,b or #000000 - #FFFFFF - See above for more information on defining colors. If not defined the outline will not be drawn.
DEFAULT: Not Present

Main Menu Up Highlight Settings

The menu up highlihgts are used when a main menu link will retract a sub menu when clicked.

Parameter 23
Attribute: Main Background Up Highlight Color
param name = "muhlbgcolor"
Value=r,g,b or #000000 - #FFFFFF - See above for more information on defining colors. If not defined the highlight will not draw a background color and any existing background image or color will be preserved.
DEFAULT: Not Present

Parameter 24
Attribute: Main Highlight Up Text Color
param name = "muhltextcolor"
Value=r,g,b or #000000 - #FFFFFF - See above for more information on defining colors.
DEFAULT: Red

Parameter 25
Attribute: Main Highlight Up Outline Color
param name = "muhloutcolor"
Value=r,g,b or #000000 - #FFFFFF - See above for more information on defining colors. If not defined the outline will not be drawn.
DEFAULT: Not Present

Sub Menu Settings

Note: Sub menu parameter names which have an s_ appended to the beginning of the name can be used to define both a default setting and a specific setting for a specific sub menu level. The default setting (the parameter name without an index) defines the 1st sub menu level. The specific settings (the parameter name with an index starting at 0, e.g. s_bgfile0) define the attributes for the sub menu level to which they correspond starting at with index 0 at sub menu level 2.

Parameter 26
Attribute: Sub Menu Level Descriptions
param name = "desc0-0-0..." - "descN-N-N..."
Value = Icon ID | Description or Description, Where Description is the message that corresponds to the index used to identify a main menu description ("maindescN") as well as its parent sub menu if applicable. To define level 1 sub menus (the first sub menu level to appear under a main menu) use "descN-N", e.g. "desc0-0" refers to the first sub menu description for the first main menu, "desc0-1" refers to the second sub menu description for the first main menu. To branch another sub menu level of a previous sub menu extend the reference, e.g. "desc0-1-0" would force a new menu to slide down under the second description in the first sub menu defined by "desc0-1", "desc0-1-1" would add another description to this new second level sub menu. Sub menus may be branched indefinitely in any configuration. To define an icon with a sub menu description use the icon ID, and vertical bar ( | ) followed by the message for the sub menu.

Parameter 27
Attribute: Sub Height
param name = "subheight"
Value = X. Where X is height of each sub menu link, measured in pixels. If left out of the applet tag or set to -1 the height is automatically set by the size of the sub menu font.

Parameter 28
Attribute: Sub Indent
param name = "subindent"
Value = X. Where x is the distance in pixels to indent each sub menu level from the previous level.
DEFAULT: 10

Parameter 29
Attribute: Sub Level Font Setting
param name = "subfont"
Value = Font Face, Style, Size, Each value must be separated by a comma and appear in the correct order (font face, style, and size) The Allowable font Java face values are Helvetica, TimesRoman, Courier, Dialog, or DialogInput. The allowable style options are plain, bold, bolditalic, or italic.
DEFAULT: Helvetica, plain, 12

Parameter 30
Attribute: Default Sub Level Color
param name = "s_color"
Value=r,g,b or #000000 - #FFFFFF - See above for more information on defining colors.
DEFAULT: Yellow

Parameter 31
Attribute: Specific Sub Level Color
param name = "s_color0" - "s_colorN"
Value=r,g,b or #000000 - #FFFFFF - See above for more information on defining colors.
DEFAULT: Yellow

Parameter 32
Attribute: Default Sub Background Image File
param name = "s_bgfile"
Value = X. Where X is the name and relative location of the background image file to use. The file should be defined relative to the location of the document containing the applet or fully qualified (e.g. http://www.mydomain.com/...).

Parameter 33
Attribute: Specific Sub Background Image File
param name = "s_bgfile0" - "s_bgfileN"
Value = X. Where X is the name and relative location of the background image file to use for a specific sub menu level.The file should be defined relative to the location of the document containing the applet or fully qualified (e.g. http://www.mydomain.com/...). The background image for all sub menus is automatically tiled.

Parameter 34
Attribute: Default Sub Menu Text Color
param name = "s_textcolor"
Value=r,g,b or #000000 - #FFFFFF - See above for more information on defining colors.
DEFAULT: Black

Parameter 35
Attribute: Specific Sub Menu Level Text Colors
param name = "s_textcolor0" - "s_textcolorN"
Value=r,g,b or #000000 - #FFFFFF - See above for more information on defining colors.

Sub Menu Highlight Settings

Parameter 36
Attribute: Highlight Text Area Only with Outline and Background Color
param name = "hlsubtextonly"
Value = true or false, true = yes, only highlight the text area, false = no, highlight the text area and extend the highlighting to include the sub menu indent space. A setting of false with an icon will force the highlight to stretch to the icons position if the icon is set left of the sub menu indent start position.
DEFAULT: False

Parameter 37
Attribute: Default Sub Background Highlight Color
param name = "s_hlcolor"
Value=r,g,b or #000000 - #FFFFFF - See above for more information on defining colors. If not defined the highlight will not draw a background color and any existing background image or color will be preserved when highlighting.
DEFAULT: Not Present

Parameter 38
Attribute: Specific Sub Background Highlight Color
param name = "s_hlcolor0" - "s_hlcolorN"
Value=r,g,b or #000000 - #FFFFFF - See above for more information on defining colors. If not defined the highlight will not draw a background color and any existing background image or color will be preserved when highlighting.

Parameter 39
Attribute: Default Sub Highlight Text Color
param name = "s_hltextcolor"
Value=r,g,b or #000000 - #FFFFFF - See above for more information on defining colors.
DEFAULT: Red

Parameter 40
Attribute: Specific Sub Highlight Text Color
param name = "s_hltextcolor0" - "s_hltextcolorN"
Value=r,g,b or #000000 - #FFFFFF - See above for more information on defining colors.
DEFAULT: Red

Parameter 41
Attribute: Default Sub Highlight Outline Color
param name = "s_hloutcolor"
Value=r,g,b or #000000 - #FFFFFF - See above for more information on defining colors.
DEFAULT: Note Present

Parameter 42
Attribute: Specific Sub Highlight Outline Color
param name = "s_hloutcolor0" - "s_hloutcolorN"
Value=r,g,b or #000000 - #FFFFFF - See above for more information on defining colors.
DEFAULT: Red

Sub Menu Up Level Highlight Settings

A third highlight state is available by customizing the up level highlight options for links which retract sub menus.

Parameter 43
Attribute: Default Sub Up Background Highlight Color
param name = "s_uhlcolor"
Value=r,g,b or #000000 - #FFFFFF - See above for more information on defining colors. If not defined the highlight will not draw a background color and any existing background image or color will be preserved when highlighting.
DEFAULT: Not Present

Parameter 44
Attribute: Specific Sub Up Background Highlight Color
param name = "s_uhlcolor0" - "s_uhlcolorN"
Value=r,g,b or #000000 - #FFFFFF - See above for more information on defining colors. If not defined the highlight will not draw a background color and any existing background image or color will be preserved when highlighting.

Parameter 45
Attribute: Default Sub Up Highlight Text Color
param name = "s_uhltextcolor"
Value=r,g,b or #000000 - #FFFFFF - See above for more information on defining colors.
DEFAULT: Red

Parameter 46
Attribute: Specific Sub Up Highlight Text Color
param name = "s_uhltextcolor0" - "s_uhltextcolorN"
Value=r,g,b or #000000 - #FFFFFF - See above for more information on defining colors.
DEFAULT: Red

Parameter 47
Attribute: Default Sub Up Highlight Outline Color
param name = "s_uhloutcolor"
Value=r,g,b or #000000 - #FFFFFF - See above for more information on defining colors.
DEFAULT: Note Present

Parameter 48
Attribute: Specific Sub Up Highlight Outline Color
param name = "s_uhloutcolor0" - "s_uhloutcolorN"
Value=r,g,b or #000000 - #FFFFFF - See above for more information on defining colors.
DEFAULT: Red

Icon File Definition

An unlimited number of icon images in varying sizes and formats may be defined and associated with any main menu link or sub menu link. Each icon is optionally referenced from the "maindesc" and "desc" tag by using the icons id which is the numbered index used in the parameter to uniquely specify the file name and location of the icon image. For more information on how to add an icon reference to a menu link see the descriptions for the "maindesc" and "desc" tags. The icons associated switch image and up image is automatically displayed when a main menu or sub menu link using the icon highlighted.

Parameter 49
Attribute: Icon Files
param name = "iconfile0" - "iconfileN"
Value = X. Where X is the name and relative location of the icon image file.The file should be defined relative to the location of the document containing the applet or fully qualified (e.g. http://www.mydomain.com/...). The icon file is the icon image that is automatically displayed when the menu or sub menu using the icon appears.

Parameter 50
Attribute: Icon Switch Files
param name = "iconswitchfile0" - "iconswitchfileN"
Value = X. Where X is the name and relative location of the icon switch image file.The file should be defined relative to the location of the document containing the applet or fully qualified (e.g. http://www.mydomain.com/...). The switch icon is automatically displayed when a menu using the switch icons associated icon file is highlighted.

Parameter 51
Attribute: Icon Up Files
param name = "iconupfile0" - "iconupfileN"
Value = X. Where X is the name and relative location of the icon up image file.The file should be defined relative to the location of the document containing the applet or fully qualified (e.g. http://www.mydomain.com/...). The up icon appears if the sub menu or main menu using the icon will retract a sub menu when clicked.

Parameter 52
Attribute: Main Icon indent
param name = "micondent"
Value = X, Where x is distance from the left edge of the applet to indent the main menu icons.
DEFAULT: 1

Parameter 53
Attribute: Sub Level Icon indent
param name = "subicondent"
Value = X, Where x is distance from the previous indent to place the icon image. Use a negative value to place the icon before the previous indent value. If using a sub menu text indent value of 0 a negative icon indent value will be required to place icons left of the lined up sub menu text.
DEFAULT: 1

URL Links

Parameter 54
Attribute: Check Previous URL Link and Do Not Load if the Same
param name = "checkprevlink"
Value = True or False, Where false forces the browser to load each URL link regardless of the last link selected. Where true will not load the same link twice (Usefull when using the applet in a frames page).
DEFAULT: false

Parameter 55
Attribute: Main Menu URL Links
param name = "mdesturl0" - "mdesturlN"
value=URL | Target or URL, where URL is the link for the specific sub menu message. URL's can be defined relative to the HTML document containing the applet or fully qualified (e.g. http://www.mydomain.com/...).

The desturl value can optionally be separated by a | to define a specific target location for the URL. To specifically target a named frame set the value to the URL than use a vertical bar ( | ) and follow it with the name of the frame or use the URL link in combination with the constants listed below. The default target location is the value set with the loadwhere tag which defaults to "_self". e.g. a URL link which loads in a frame named content... "...myfolder/mylink.htm|content", e.g. a URL link which uses the default target location... "...myfolder/mylink.htm".

"_self" show in the current frame
"_parent" show in the parent frame
"_top" show in the top-most frame
"_blank" show in a new unnamed top-level window
"name" show in a new top-level window named name
"frame name" show in the frame named frame name

Parameter 56
Attribute: Sub Menu Level URL Links
param name = "desturl0-0-0..." - "desturlN-N-N..."
value=URL | Target or URL, where URL is the link for the specific sub menu message. The "N-N-N" index must correspond to the sub menus associated desc index (see the "desc" tag for more information). URL's can be defined relative to the HTML document containing the applet or fully qualified (e.g. http://www.mydomain.com/...).

The desturl value can optionally be separated by a | to define a specific target location for the URL. To specifically target a named frame set the value to the URL than use a vertical bar ( | ) and follow it with the name of the frame or use the URL link in combination with the constants listed below. The default target location is the value set with the loadwhere tag which defaults to "_self". e.g. a URL link which loads in a frame named content... "...myfolder/mylink.htm|content", e.g. a URL link which uses the default target location... "...myfolder/mylink.htm".

"_self" show in the current frame
"_parent" show in the parent frame
"_top" show in the top-most frame
"_blank" show in a new unnamed top-level window
"name" show in a new top-level window named name
"frame name" show in the frame named frame name

Parameter 57
Attribute: Default Load Destination URL Where?
param name="loadwhere"
The "loadwhere" tag specifies where the document specified in the "desturlN-N-N" and "mdesturlN" parameters should be loaded. The default is "_self". A value equal to the name (case sensitive) of a frame will load the document in that frame.
"_parent" show in the parent frame
"_top" show in the top-most frame
"_self" show in the current frame
"_blank" show in a new unnamed top-level window
"name" show in a new top-level window named name
"frame name" show in the frame named frame name

Note: When targeting a frame location with the name of the frame make certain that the case and names are typed identically. If the applet cannot find the frame the document will be loaded in a new window.

Sliding Tree Menu, © 1997, OpenCube Technologies